# Administrer Sonarqube

## Enrôlement

Lors du processus d'enrôlement, les étapes suivantes sont pré-créés côté Sonarqube :

* Votre compte administrateur
* Un groupe associé à votre projet
* Un template de permission pour vos projet

Il reste des actions à effectuer par vous pour configurer le service.

## Créé la clé Gitlab pour récupérer un projet

Cette clé permettra à Sonarqube de connaître les projets à importer.
Pour cela, il faut :

* Aller dans la page de gestion des tokens du groupe : <https://gitlab.gpf-tech.ign.fr/groups/VOTRE_GROUPE/-/settings/access_tokens>
* Définir un token comme indiqué

![Gitlab token access](../img/gitlab_sonar_access_token.png)

**ATTENTION:** Conserver la valeur du token pour pouvoir l'utiliser ultérieurement.

A noter que si vous préférez un filtrage de droits plus fin, vous pouvez également déclarer le token uniquement au niveau projet.
Le process est identique mais l'interface à utiliser sera : <https://gitlab.gpf-tech.ign.fr/VOTRE_GROUPE/VOTRE_PROJET/-/settings/access_tokens>

## Créé la clé API pour les pipelines Gitlab

### Créer une clé par projet

Lors du processus de création d'un projet, Sonarqube vous proposera de générer un token pour votre projet.

Ce token sera à valoriser dans une variable SONAR_TOKEN, associée à votre projet Gitlab : <https://gitlab.gpf-tech.ign.fr/VOTRE_GROUPE/VOTRE_PROJET/-/settings/ci_cd>

### Créer une clé pour le groupe

Pour éviter de générer un token / projet, il est également possible de générer un token Sonarqube pour le compte admin :

* Aller sur : <https://sonar.gpf-tech.ign.fr/account/security/>
* Indiquer un nom et cliquer sur le bouton `Generate`

Ce token sera à valoriser dans une variable SONAR_TOKEN associée à votre groupe Gitlab : <https://gitlab.gpf-tech.ign.fr/VOTRE_GROUPE/-/settings/ci_cd>

## Créer un projet

* Aller dans `create project`
* Choisir `From Gitlab`
* Indiquer la clé généré précédemment
* Dans la liste des projets, cliquer sur le bouton `set up` du projet souhaité
* Dans la page d'accueil du projet, aller dans `Project Information` et copier la variable `Project Key`

![Project Key](../img/sonar_project_key.png)

Cette clé doit être copiée dans une variable SONAR_PROJECT_KEY associée à votre projet Gitlab : <https://gitlab.gpf-tech.ign.fr/VOTRE_GROUPE/VOTRE_PROJET/-/settings/ci_cd>
