# Charts Minio

## Minio ?

[Minio](https://min.io/) est une solution performante de stockage objet suivant le protocole AWS S3. Dans le cadre de la géoplateforme, cette solution n'est pas utilisée mais elle est facilement déployable et vous permettra de disposer d'un stockage objet dans vos environnements "bac à sable".

Nous conseillons l'utilisation du chart distribué par Bitnami, disponible [ici](https://github.com/bitnami/charts/tree/master/bitnami/minio)

L'ensemble des paramètres personnalisables est disponible [ici](https://github.com/bitnami/charts/blob/master/bitnami/minio/values.yaml)

La solution minio est composée en 2 services :

* **minio-console** : interface graphique de management
* **minio** : les apis

## Utilisation

### Importer le chart

Dans votre projet `deploiement`, il suffit d'ajouter la dépendance dans votre fichier `Chart.yml` principal :

```yml
dependencies:
  ...
  - name: minio
    version: "*"
    repository: "https://charts.bitnami.com/bitnami"
    condition: minio.enabled
    alias: minio
  ...
```

### Surcharger les valeurs par défaut

Pour surcharger les valeurs du charts d'origine, le plus simple est de le faire depuis votre fichier `values.xml` principal :

```yml
# Surcharge pour minio
minio:
  enabled: true
  auth:
    rootUser: admin
    rootPassword: <mdp admin>
  ingress:
    enabled: true
    ingressClassName: "nginx"
    hostname: "minio-console-<groupe>.dev.gpf-tech.ign.fr"
    annotations: 
      cert-manager.io/cluster-issuer: letsencrypt-manager-cert
    tls: true
  apiIngress:
    enabled: true
    ingressClassName: "nginx"
    hostname: "minio-<groupe>.dev.gpf-tech.ign.fr"
    annotations:
      cert-manager.io/cluster-issuer: letsencrypt-manager-cert
    tls: true
```

### Ajouter un utilisateur au démarrage

Pour initier le projet avec d'autres utilisateur que l'administrateur, il faut ajouter le bloc suivant dans votre fichier `values.xml`

```yml
minio:
  ...
  provisioning:
    enabled: true
    users:
      - username: <nom>
        password: <mdp>
        disabled: false
        policies:
          - readwrite
        setPolicies: true
      ...
      - username: <nom N>
        password: <mdp N>
        disabled: false
        policies:
          - readwrite
        setPolicies: true
```

### Créer des buckets au démarrage

Pour initier le projet avec un ou plusieurs bucket, il faut ajouter le bloc suivant dans votre fichier `values.xml`

```yml
minio:
  ...
  provisioning:
    enabled: true
    ...
    buckets:
      - name: bucket1
      ...
      - name: bucketN
```
