# Dependency track

## Description

Ce template permet d'ajouter :

* Un job qui génère un bom au format [OWASP CyloneDX](https://cyclonedx.org) et le soumets à Dependency track pour analyse

Il possède comme pré-requis :

* La variable DT_TOKEN contenant votre token Depencency Track doit être présente dans votre CI/CD
* La variable DT_HOST_URL doit être présente dans votre CI/CD
* La variable DT_PROJECT_KEY contenant l'identifiant de votre projet dans Dependency Track doit être présente dans votre CI/CD

Les variables DT_TOKEN et DT_HOST_URL sont configurées au niveau du groupe lors de la création de ce dernier. 
La variable DT_PROJECT_KEY devra être configurée au niveau du dépôt après création d'un projet dans DependencyTrack avec l'identifiant de ce dernier.

Pour plus d'informations, voir la rubrique [Administrer Dependency Track](../../admin/dependencyTrack.md)

## Utilisation

Ajouter le code suivant dans votre fichier `.gitlab-ci.yml`

```yml
include:
  - project: geoplateforme/templates
    ref: main
    file:
      - '/ci/dependencyTrack.yml'
```

Ce job se déclenche sur l'étape `test`

## Limitations

Pour le moment, cette fonctionnalité n'est disponible que pour les langages suivants :

* Java sous Maven

Si vous avez un besoin pour la mise en place d'un job pour un autre langage, vous pouvez soumettre la demande via un ticket sur le [projet du support de la géoplateforme](https://gitlab.gpf-tech.ign.fr/geoplateforme/support/-/issues)
