# Versioning

## Description

Ce template permet de gérer :

* La version du chart et la version applicative
* La procédure de tag/release 

Il possède comme pré-requis :

* un chart Helm (emplacement par défaut `./chart/Chart.yaml` configurable avec la variable de CI `CHART_PATH`)
* La variable `GITLAB_RELEASE_TOKEN` contenant votre access token qui doit être présente dans votre CI/CD au niveau de la configuration du groupe. Ce token est nécessaire afin de pouvoir effectuer toutes les opérations git sur le repository.

## Utilisation

L'étape de récupération des versions doit être exécutée avant votre premier stage, l'étape de release doit être exécutée après votre dernier stage.

### Récupération des versions

> :warning: Ce job est par défaut exécuté en stage `.pre`.
Si vous souhaitez qu'il soit exécuter à un autre moment, vous pouvez le surcharger de la manière suivante :

```yml
votre_nom_de_job:
 extends: .prepare-version
 stage: votre_stage
```

### Release des versions

> :warning: Ce job est par défaut exécuté en stage `.post`.
Si vous souhaitez qu'il soit exécuter à un autre moment, vous pouvez le surcharger de la manière suivante :

```yml
votre_nom_de_job:
 extends: .release
 stage: votre_stage
```
