# Générer un rapport Dependency Track

L'outil [Dependency Track](https://dependencytrack.org/) permet d'obtenir un rapport de vulnérabilité du projet basé sur l'analyse d'un [SBOM](https://cyclonedx.org/capabilities/#software-bill-of-materials-sbom).

La documentation est disponible [ici](https://docs.dependencytrack.org)

## Principe

Dependency Track s'utilise en 2 étapes :

* Génération d'un SBOM
* Upload du SBOM dans dependency track

### Génération

Un SBOM est un fichier JSON respectant la norme indiquée [ici](https://cyclonedx.org/docs/1.4/json/)

L'OWASP fournit des outils d'aide à la génération de SBOM sur son site [Cyclone DX](https://cyclonedx.org/) et notamment via [la liste de plugin pour Cyclone DX](https://github.com/CycloneDX).

### Upload

#### Via api

Dependency Track est pensé pour être utilisé en priorité via ses APIs.

Les spécifications sont disponibles [ici](https://dependency-track.gpf-tech.ign.fr/api/swagger.json)

Exemple d'appel curl type :

```sh
curl -X POST https://dependency-track.gpf-tech.ign.fr/api/v1/bom -H "Content-Type: multipart/form-data" -H "X-Api-Key: <votre cle api du projet>" -F "project=<l'uid du projet sur dependency track>" -F "bom=@<fichier sbom>"
```

#### Via l'interface

Une fois le BOM généré, il est possible de le téléverser directement depuis le tableau de bord dependency track.

![UploadBom](../img/DT_upload_bom.png)

## Utilisation dans la géoplateforme

Un [template](../support/ci/dependencyTrack.md) est disponible pour vous aider à la mise en place d'une génération de rapport via votre CI.

## Limitations

### Compatibilité de langages

les langages actuellement reconnu par Dependency Track sont les suivants :

* Cargo (Rust)
* Composer (PHP)
* Gems (Ruby)
* Hex (Erlang/Elixir)
* Maven (Java)
* NPM (Javascript)
* Gradle (Java)
* NuGet (.NET)
* Pypi (Python)

Pour plus d'information sur la génération de BOM pour ces langages, se référer à [la liste de plugin pour Cyclone DX](https://github.com/CycloneDX).

### Nombre de branches analysables

Le rapport n'est disponible que pour la branche principale (`main`).
